/*
 * The followin class is extact from kawa-1.6.55 gnu/expr/LambdaExp.eval(Environment env).
 * 
 * It shows a Kaffe memory corruption, (maybe with Deflate class and kaffe_zalloc)
 * 
 * # kaffe ZipBug
 * new java.util.zip.ZipEntry
 * Kaffe: ./mem/gc-mem.c:254: gc_heap_malloc: Assertion `blk->free != 0' failed.
 */

import java.io.*;
import java.util.zip.*;

class ZipBug {

    /** Used to control with .zip files dumps are generated. */
    public static String dumpZipPrefix;
    public static int dumpZipCounter;

    byte[][] classes;
    String[] classNames;
    int numClasses;

    private void prepare() {
	numClasses = 5;
	classes = new byte[numClasses][];
	classNames = new String[numClasses];

	for(int i = 0; i < numClasses; i++) {
	    classNames[i] = "Class" + i;
	    classes[i] = new byte[1024];
	    for (int j = 0; j < classes[i].length; j++)
		classes[i][j] = (byte)j;
	}
    }


    private void zipit() {
	try {
	    if (dumpZipPrefix != null)
	    {
		StringBuffer zipname = new StringBuffer(dumpZipPrefix);
		if (dumpZipCounter >= 0)
		    zipname.append(++dumpZipCounter);
		zipname.append(".zip");
		java.io.FileOutputStream zfout
		    = new java.io.FileOutputStream(zipname.toString());
		java.util.zip.ZipOutputStream zout
		    = new java.util.zip.ZipOutputStream(zfout);
		for (int iClass = 0;  iClass < numClasses;  iClass++)
		{
		    String clname
			= classNames[iClass].replace ('.', '/') + ".class";
System.err.println("new java.util.zip.ZipEntry"); System.err.flush();
		    java.util.zip.ZipEntry zent
			= new java.util.zip.ZipEntry (clname);
System.err.println("zent.setSize"); System.err.flush();
		    zent.setSize(classes[iClass].length);
System.err.println("new java.util.zip.CRC32"); System.err.flush();
		    java.util.zip.CRC32 crc = new java.util.zip.CRC32();
System.err.println("crc.update"); System.err.flush();
		    crc.update(classes[iClass]);
System.err.println("zent.setCrc"); System.err.flush();
		    zent.setCrc(crc.getValue());
System.err.println("zent.setMethod"); System.err.flush();
		    zent.setMethod(java.util.zip.ZipEntry.STORED);
System.err.println("zout.putNextEntry"); System.err.flush();
		    zout.putNextEntry(zent);
System.err.println("zout.write"); System.err.flush();
		    zout.write(classes[iClass]);
		}
		zout.close ();
	    }
	}
	catch (IOException e) {
	    e.printStackTrace();
	}
    }

    static void main(String args[]) {
	dumpZipPrefix = "kawa-zip-dump-";
	ZipBug z = new ZipBug();
	z.prepare();
	z.zipit();
    }
}

